// Next.js API route support: https://nextjs.org/docs/api-routes/introduction
import type { NextApiRequest, NextApiResponse } from "next";
import client from "@/lib/mongodb";
import { withIronSessionApiRoute } from "iron-session/next";
import { sessionOptions } from "@/lib/session";
import { Exam, InstructorGender, Variant } from "@/interfaces/exam";
import { getExams } from "@/utils/exams.be";
import { Module } from "@/interfaces";
import { getUserCorporate } from "@/utils/groups.be";

const db = client.db(process.env.MONGODB_DB);

export default withIronSessionApiRoute(handler, sessionOptions);

async function handler(req: NextApiRequest, res: NextApiResponse) {
	if (req.method === "GET") return await GET(req, res);
	if (req.method === "POST") return await POST(req, res);

	res.status(404).json({ ok: false });
}

async function GET(req: NextApiRequest, res: NextApiResponse) {
	if (!req.session.user) {
		res.status(401).json({ ok: false });
		return;
	}

	const { module, avoidRepeated, variant, instructorGender } = req.query as {
		module: Module;
		avoidRepeated: string;
		variant?: Variant;
		instructorGender?: InstructorGender;
	};

	const exams: Exam[] = await getExams(db, module, avoidRepeated, req.session.user.id, variant, instructorGender);
	res.status(200).json(exams);
}

async function POST(req: NextApiRequest, res: NextApiResponse) {
	if (!req.session.user) {
		res.status(401).json({ ok: false });
		return;
	}

	const { module } = req.query as { module: string };
	const corporate = await getUserCorporate(req.session.user.id);

	const session = client.startSession();

	try {
		const exam = {
			...req.body,
			module: module,
			owners: [
				...(["mastercorporate", "corporate"].includes(req.session.user.type) ? [req.session.user.id] : []),
				...(!!corporate ? [corporate.id] : []),
			],
			createdBy: req.session.user.id,
			createdAt: new Date().toISOString(),
		};

		await session.withTransaction(async () => {
			const docSnap = await db.collection(module).findOne({ id: req.body.id }, { session });

			if (docSnap) {
				throw new Error("Name already exists");
			}

			await db.collection(module).insertOne(
				{ id: req.body.id, ...exam },
				{ session }
			);
		});
		
		res.status(200).json(exam);

	} catch (error) {
		console.error("Transaction failed: ", error);
		res.status(500).json({ ok: false, error: (error as any).message });
	} finally {
		session.endSession();
	}
}
